stop = False
while not(stop):
    n,m = map(int,input().split())
    if n == 0 and m == 0:
        stop = True
        break  
    if n == 1:
        print("1: 0")
    elif n != m+1:
        for _ in range(m):
            _ = input()
        print("Impossible")
    else:
        cnt = [0] * n
        for _ in range(m):
            a,b = map(int,input().split())
            cnt[a] += 1
            cnt[b] += 1
        morethan1 = []
        for i in range(n):
            if cnt[i] > 1:
                morethan1.append(i)
        if len(morethan1) > 2:
            print("Impossible")
        elif len(morethan1) == 2:
            a,b = morethan1
            print("4:",a,b,b,a)
        elif len(morethan1) == 1:
            a = morethan1[0]
            print("2:",a,a)
        else:
            print("2: 0 0")
    t = input()
